#ifndef _tcp_connection_h_
#define _tcp_connection_h_

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "senderreceiver.H"

class TCP_Sender : public virtual Sender
{
 public:
  TCP_Sender(char *to_host, unsigned short to_port, char *src_host=NULL, unsigned short src_port=0);
  ~TCP_Sender();
  int sendbuff(char*, unsigned long);
  void set_output_interval(double i)
    {
      output_interval=i;
    }
  char *version();
  int get_fh(){return sock;}
 
 private:
  char *packetbuff;
  unsigned long amount;
  int sock;
  double output_interval;
  double gettimeasdouble();
  double bandwidth;
  struct sockaddr_in src_addr, to_addr;
  struct hostent *src_hent, *to_hent;
  char *to_host, *src_host;
  unsigned short to_port, src_port;
  double last_call;
};



class TCP_Receiver : public virtual Receiver 
{
public:
  TCP_Receiver(unsigned short port, char *host=NULL);
  ~TCP_Receiver();
  long int receivebuff(char *, long int);
  void set_output_interval(double i){output_interval=i;}
  char *version();
  int get_fh(){return sock;}

 private:
  double gettimeasdouble();


  double output_interval;
  char *packetbuff;
  double last_call;
  double bandwidth;

  int sock, socka;
  struct sockaddr_in addr;   // this host
  struct sockaddr_in daddr;  // the other host 
  int daddr_len;
  struct hostent *hent;

  char *host;
  unsigned short port;
};


// some toolkitfunctions

// split destination like sancho.unibe.ch:5000:5000 into parts

int split_destination(char *s, char *dhost, int *dport, char *shost, int *sport);
  

#endif




















