#ifndef _ping_h_
#define _ping_h_

struct icmp_header{
  char type;
  char code;
  unsigned short cksum;
  unsigned short id;
  unsigned short sn;
  char data;
};

class Ping : public virtual LOB, public virtual VRschedObj, public virtual ForwarderIF
{
public:
  Ping(LOBenv*);		//- the constructor 
  ~Ping();			//- the desctructor 
  int send_a_ping();
  RawSock *sin, *sout;
  char *id(){return "ping";}
  int interrupt(VRevent*);
  int forward(Sock*, Packet *);
  VRevent *event;

private:
  unsigned long d_addr;
  unsigned short ping_id, ping_sn;
  double *pinghash; 
  void show_help();
  int verbose;

  int ping_rep;
  int ping_maxwait;
  int cnt;
  int rcnt;
  double rtt_min, rtt_max, rtt_avg;
};

#endif


