#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/*
  this is platform depended code !
  use only on intel
*/

struct IPH{
  unsigned ihl:4;
  unsigned version:4;
  unsigned tos:8;
  unsigned len:16;
  unsigned id:16;
  unsigned frag:16;
  unsigned ttl:8;
  unsigned prot:8;
  unsigned crc:16;
  unsigned source:32;
  unsigned dest:32;
};


int main(int argc, char **argv)
{
  struct IPH ip;
  struct in_addr in;
  int i,x,n;
  char buffer[2048];

  if(argc!=2){
    puts("usage:   ipdump offset");
    exit(0);
  }

  n=atoi(argv[1]);

  for(i=0;i<n;)i+=read(0, &x, 1);

  while(1) {
    read(0,&ip, sizeof(struct IPH));
  
    printf("version: %d\n",ip.version);
    printf("ihl:     %d\n",ip.ihl);
    printf("tos:     %d\n",ip.tos);
    printf("totlen:  %d\n",ntohs(ip.len));
    printf("id:      %d\n",ntohs(ip.id));
    printf("ttl:     %d\n",ip.ttl);
    printf("prot:    %d\n",ip.prot);
    in.s_addr=ip.source;
    printf("source:  %s\n",inet_ntoa(in));
    in.s_addr=ip.dest;
    printf("dest:    %s\n",inet_ntoa(in));
    read(0,buffer,ntohs(ip.len));
    puts("-------------------------------");
  }
  return 0;
}


