#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/time.h>

/*
  this is platform depended code !
  use only on intel
*/

struct IPH{
  unsigned ihl:4;
  unsigned version:4;
  unsigned tos:8;
  unsigned len:16;
  unsigned id:16;
  unsigned frag:16;
  unsigned ttl:8;
  unsigned prot:8;
  unsigned crc:16;
  unsigned source:32;
  unsigned dest:32;
};

void print_ip(struct IPH *);

int main(int argc, char **argv)
{
  struct IPH *ip;
  char buffer[2048];
  int fh, r, m, len;
  fd_set rfds; fd_set wfds;
  

  fh=open(argv[1],O_RDWR);
  ip=(struct IPH*)buffer;
  

  for(m=0;1;++m){
    FD_ZERO(&rfds);
    FD_ZERO(&wfds);
    FD_SET(fh,&rfds);
    FD_SET(fh,&wfds);


    r=select(fh+1, &rfds, &wfds, NULL, NULL);
    
    if(FD_ISSET(fh,&rfds)){
      //      puts(" read possible");
      len=read(fh,buffer,2048);
 
      if(ip->version !=4 || ntohs(ip->len)!=len){
	puts("-------------------------------");
	print_ip(ip);
	puts("-------------------------------");
      }
    }
 
  }
  return 0;
}

void print_ip(struct IPH *ip){
  // struct in_addr in;

  printf("ver: %4d ",ip->version);
  printf("ihl: %4d ",ip->ihl);
  printf("tos: %4d\n",ip->tos);
  printf("len: %4d ",ntohs(ip->len));
  printf("id:  %4d ",ntohs(ip->id));
  printf("ttl: %4d\n",ip->ttl);
  printf("pro: %4d\n",ip->prot);
  //in.s_addr=ip->source;
  // printf("source:  %s\n",inet_ntoa(in));
  //in.s_addr=ip->dest;
  //printf("dest:    %s\n",inet_ntoa(in));
  
}




