#ifndef _api_filter_h_
#define _api_filter_h_

class ForwarderIF;
class ProtocolStack;

//> FILTER_REC
struct FILTER_REC 
{
  ForwarderIF *forwarder;	//- the address of the appropriate ForwarderIF class
  int prio;			//- the position the filter has to be applied
  unsigned long source_ip;	//- the source ip address, NAK is 0xfffffffff 
  unsigned long source_nm;	//- netmask of the source address 
  unsigned long dest_ip;	//- the destination address, NAK is 0xffffffff 
  unsigned long dest_nm;	//- the netmask of the destination address
  unsigned int tos;		//- the tos value
  unsigned int proto;		//- the protocol 
  int ipopt_type;		//- IP options type 
  unsigned long ipopt_value;	//- and value  
  int mode;			//- bit 1 (0 copy: 1 move) bit 2 (0 nondefrag:1 defrag)  
  char name[32];		//- comment
  unsigned short cb_handle;	//- the handle used to add the filter
};
//<

//> PROTOCOLSTACK_CB
struct PROTOSTACK_CB : public VRCB
{
  ProtocolStack *stack;
  int protocol;
};
//<

//> PROTOCOLSTACK_RB
struct PROTOSTACK_RB : public VRRB
{
  int protocol;			// Protocol Number, 0 on error
};
//<


//> FILTER_CB
struct FILTER_CB : public VRCB
{
  unsigned short filter_command;	//- the command specifier
};
//<

//> FILTER_ADDDEL_CB
struct FILTER_ADDDEL_CB : public FILTER_CB
{
  struct FILTER_REC filter;	//- the filter to be applied
};
//<

//> FILTER_RB
struct FILTER_RB : public VRRB
{
  struct FILTER_REC filter;	//- the filter record
};
//<

#endif

