#ifndef _qco_h_
#define _qco_h_

#define QUEUE_ACK 0
#define QUEUE_NAK 1


#define QCTYPEID_DROPTAIL 1
#define QCTYPEID_TBF 2
#define QCTYPEID_CLASSIFIER 3
#define QCTYPEID_SCHEDULER 4
#define QCTYPEID_TRIO 5
#define QCTYPEID_DSMARKER 6


#include "packet.H"
#include "api.H"

class QCroot;


class QCO
{
  friend QCroot;
public:
  QCO(QCroot*);

  virtual ~QCO()
  {
    return;
  }

  virtual char *id()		// returns a simple identification string
  {
    return "QueueChainObject";
  }

  virtual unsigned short type_id()	// returns the component id of the component
  {
    return 0xffff;
  }

  // enques a packet, 
  //    returns QUEUE_NAK if not possible 
  //    return QUEUE_ACK if enque successful
  //
  virtual int enque(Packet *)	
  {
    return QUEUE_NAK;
  }

  // deques a packet, 
  //    returns NULL if no packet availabke
  //    returns packet pointer deque successful
  //
  virtual Packet *deque(QCO *)	
  {
      return NULL;
  }

  // checks whether a packet is available or not
  // packer stays in queue
  //    returns NULL if no packet availabke
  //    returns packet pointer deque successful
  //
  virtual Packet *nextdeque(QCO *) 
  {
    return NULL;
  }

  virtual VRRB* APIconfigure(VRCB *in) // component specific config
  {
    return NULL;
  }
  
  virtual int unnext(QCO *q);
  virtual int unprev(QCO *q);
  virtual int next(QCO *);
  virtual int prev(QCO *q);

  bool isusing(QCO*);
  int get_id(QCO *q);
  int drop(Packet *);

protected:
  VR *vr;
  int nof_ins;
  int max_nof_ins;
  int nof_outs;
  int max_nof_outs;
  QCO **outs;
  QCO **ins;
  QCroot *qr;  // the root class
};

#endif






