#ifndef _routing_h_
#define _routing_h_


class RTableRec
{
public:
  RTableRec(char *d, char *s, int p, int t, unsigned long v);
  RTableRec(unsigned long ip, unsigned long nm, unsigned long v);
  RTableRec(Packet *);
  RTableRec();
  ~RTableRec();

  int set(char *d, char *s, int p, int t, unsigned long v);

  bool equals(RTableRec*);
  bool gt(RTableRec*);
  bool lt(RTableRec*);
  int hits(Packet*);
  void clear();
  void init();

  unsigned long  sip_add;  // source
  unsigned long  snm_add; 
  int snm_num;
  unsigned long  dip_add;  // dest
  unsigned long  dnm_add;
  int dnm_num;
  unsigned short proto;
  unsigned char  tos;
  unsigned long content;
};



class RTable 
{
public:
  volatile int busy;
  RTable(int n=0xffff);
  ~RTable();
  int add(RTableRec&); 
  int del(RTableRec&);
  RTableRec* lookup(Packet*);

  RTableRec **table;
  int nof_allocated;
  int nof_entries;
  void cleanup();
  void sort();
};


class Routing
{
public:
  Routing(VR*);
  ~Routing(); 
  /*
   * route packet, 0xffff if no route found
   * interface number if successful
   */
  int route(Packet *);
  VRRB* APIconfigure(VRCB *in);
  Interface *if_lookup(Packet *);
  void cleanup();
private:
  VR *vr;
  RTable *table;
  void RTableRec2ROUTE_VRRB(RTableRec *r, ROUTE_RECORD_VRRB *v);
  void RTableRec2ROUTE_RECORD(RTableRec *r, ROUTE_RECORD *v);

};



#endif



