#ifndef _tools_h_
#define _tools_h_

#include <sys/time.h>
#include <stdio.h>
#include "packet.H"


/**
 * command line parsing and output
 */
int fhprintf(int fh, const char *format, ...);
int fhputs(const char *s, int fh);

/*
 *
 */				
char *configlinesplit(char *s);	// splits a line in a keyword and the rest  
int istrue(char*);		// returns true if the string means true (on, yes, ...)

/// check wether a string is a number
int isnumber(char *s);
/// 
int arg_query(int argc, char **argv, char p, char *option, int len);
/// contains the string a valid ip address ??
int valid_ip(char *);
/// fills the string with dashes
char *dashed(char *, int);
/// fills the string with dashes
char *dashed(char *);
/// strips trailing whitespaces and commandcodes
/// at the end of a string
int strip_trailing(char *, char*);
/// chaecks a commandline for a specific command line parameter
int getargument(char *buffer, char *key, char *dest, int maxlen);
/// 
char *int2bitstring(int);

/// returns the Unix time as double
double gettimeasdouble();
/// converts the double-time to the Unix format
void double2tv(double, struct timeval *);
/// converts a Unix timeval structure to the double format
double tv2double(struct timeval *);


/**
 *  ip address and header functions
 */
char *proto_id2char(int);
int ip_header_check(Packet *, unsigned short);
char *n2char(unsigned long l);
unsigned long char2n(char *s);
unsigned short cksum(char *, int);
int nm2n(unsigned long);
unsigned long n2nm(int); 
int char2ipnm(char *, unsigned long*, unsigned long*);
char *pkt2char(Packet*);
unsigned long hostname2n(char*);
char *ipnm2char(unsigned long ip, unsigned long nm);


#endif






